<?php

namespace Drupal\feeds_xls\Feeds\CustomSource;

use Drupal\Core\Form\FormStateInterface;
use Drupal\feeds\Feeds\CustomSource\BlankSource;

/**
 * An XLS source.
 *
 * @FeedsCustomSource(
 *   id = "xls",
 *   title = @Translation("XLS column"),
 * )
 */
class XlsSource extends BlankSource {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state);

    // Add description.
    $form['value']['#description'] = $this->configSourceDescription();
    return $form;
  }

  /**
   * Returns the description for a single source.
   *
   * @return \Drupal\Core\StringTranslation\TranslatableMarkup|null
   *   A translated string if there's a description. Null otherwise.
   */
  protected function configSourceDescription() {
    if ($this->feedType->getParser()->getConfiguration('no_headers')) {
      return $this->t('Enter which column number of the Xls file to use: 0, 1, 2, etc.');
    }
    return $this->t('Enter the exact Xls column name. This is case-sensitive.');
  }

}
